from .download import download_zip
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "assets.zip",down_path)
download_zip(xz_url + "icons.zip",down_path)

bl_info = {
    "name" : "Alt Tab Lighting",
    "author" : "Fluffy", 
    "description" : "",
    "blender" : (3, 0, 0),
    "version" : (0, 0, 1),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os
from random import uniform
from .easybpy import *


addon_keymaps = {}
_icons = None
light_icon_gallery = {'sna_list': [], }
main_ui = {'sna_list': [], }
_item_map = dict()


def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


class SNA_OT_Disable_Lights_2584A(bpy.types.Operator):
    bl_idname = "sna.disable_lights_2584a"
    bl_label = "Disable Lights"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        for i_73019 in range(len(bpy.context.view_layer.objects)):
            if (bpy.context.view_layer.objects[i_73019].type == 'LIGHT'):
                bpy.context.view_layer.objects[i_73019].hide_select = True
                bpy.context.view_layer.objects[i_73019].hide_viewport = True
                bpy.context.view_layer.objects[i_73019].hide_render = True
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Enable_Lights_28E11(bpy.types.Operator):
    bl_idname = "sna.enable_lights_28e11"
    bl_label = "Enable Lights"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        for i_30269 in range(len(bpy.context.view_layer.objects)):
            if (bpy.context.view_layer.objects[i_30269].type == 'LIGHT'):
                bpy.context.view_layer.objects[i_30269].hide_select = False
                bpy.context.view_layer.objects[i_30269].hide_viewport = False
                bpy.context.view_layer.objects[i_30269].hide_render = False
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_icongallery_enum_items(self, context):
    enum_items = [
    ['Split Cold', 'Split Cold', 'Split Cold', _icons['splitcold.png'].icon_id],
    ['Ice', 'Ice', 'Ice', _icons['ice.png'].icon_id],
    ['Gentle Cold', 'Gentle Cold', 'Gentle Cold', _icons['gentlecold.png'].icon_id],
    ['Clean White', 'Clean White', 'Clean White', _icons['cleanwhite.png'].icon_id],
    ['Radial Stage', 'Radial Stage', 'Radial Stage', _icons['radialstage.png'].icon_id],
    ['Deep Purple', 'Deep Purple', 'Deep Purple', _icons['deeppurple.png'].icon_id],
    ['Split Warm', 'Split Warm', 'Split Warm', _icons['splitwarm.png'].icon_id],
    ['Warm Morning', 'Warm Morning', 'Warm Morning', _icons['warmmorning.png'].icon_id],
    ['Pastel', 'Pastel', 'Pastel', _icons['pastel.png'].icon_id],
    ['Gentle Warm', 'Gentle Warm', 'Gentle Warm', _icons['gentlewarm.png'].icon_id],
    ['Warm Pink', 'Warm Pink', 'Warm Pink', _icons['warmpink.png'].icon_id],
    ['Soft Spot', 'Soft Spot', 'Soft Spot', _icons['softspot.png'].icon_id],
    ['Soft Warm', 'Soft Warm', 'Clean White', _icons['softwarm.png'].icon_id],
    ['Hot n Cold', 'Hot n Cold', 'Hot n Cold', _icons['hotncold.png'].icon_id],
    ['Toxic', 'Toxic', 'Toxic', _icons['toxic.png'].icon_id],
    ['Setup 1', 'Setup 1', 'Setup 1', _icons['s1.png'].icon_id],
    ['Setup 2', 'Setup 2', 'Setup 2', _icons['s2.png'].icon_id],
    ['Setup 3', 'Setup 3', 'Setup 3', _icons['s3.png'].icon_id],
    ['Setup 4', 'Setup 4', 'Setup 4', _icons['s4.png'].icon_id],
    ['Setup 5', 'Setup 5', 'Setup 5', _icons['s5.png'].icon_id],
    ['Setup 6', 'Setup 6', 'Setup 6', _icons['s6.png'].icon_id],
    ['Setup 7', 'Setup 7', 'Setup 7', _icons['s7.png'].icon_id],
    ['Setup 8', 'Setup 8', 'Setup 8', _icons['s8.png'].icon_id],
    ['Setup 9', 'Setup 9', 'Setup 9', _icons['s9.png'].icon_id],
    ['Setup 10', 'Setup 10', 'Setup 10', _icons['s10.png'].icon_id],
    ['Setup 11', 'Setup 11', 'Setup 11', _icons['s11.png'].icon_id],
    ['Setup 16', 'Setup 16', 'Setup 16', _icons['s16.png'].icon_id],
    ['Setup 19', 'Setup 19', 'Setup 19', _icons['s19.png'].icon_id],
    ['Setup 20', 'Setup 20', 'Setup 20', _icons['s20.png'].icon_id],
    ['Setup 21', 'Setup 21', 'Setup 21', _icons['s21.png'].icon_id],
    ['Setup 22', 'Setup 22', 'Setup 22', _icons['s22.png'].icon_id],
    ['Setup 23', 'Setup 23', 'Setup 23', _icons['s23.png'].icon_id],
    ['Setup 24', 'Setup 24', 'Setup 24', _icons['s24.png'].icon_id],
    ['Setup 25', 'Setup 25', 'Setup 25', _icons['s25.png'].icon_id],
    ['Setup 26', 'Setup 26', 'Setup 26', _icons['s26.png'].icon_id],
    ['Setup 27', 'Setup 27', 'Setup 27', _icons['s27.png'].icon_id],
    ['Setup 28', 'Setup 28', 'Setup 28', _icons['s28.png'].icon_id],
    ['Setup 30', 'Setup 30', 'Setup 30', _icons['s29.png'].icon_id],
    ['Setup 29', 'Setup 29', 'Setup 29', _icons['s30.png'].icon_id],
    ['Setup 31', 'Setup 31', 'Setup 31', _icons['s31.png'].icon_id],
    ['Setup 32', 'Setup 32', 'Setup 32', _icons['s32.png'].icon_id],
    ['Setup 33', 'Setup 33', 'Setup 33', _icons['s33.png'].icon_id],
    ['Setup 34', 'Setup 34', 'Setup 34', _icons['s34.png'].icon_id],
    ['Setup 35', 'Setup 35', 'Setup 35', _icons['s35.png'].icon_id]
    ]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


class SNA_OT_Appendicon_Dbe16(bpy.types.Operator):
    bl_idname = "sna.appendicon_dbe16"
    bl_label = "AppendICON"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        before_data = list(bpy.data.collections)
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'LightingPresets.blend') + r'\Collection', filename=str(bpy.context.scene.sna_icongallery), link=False)
        new_data = list(filter(lambda d: not d in before_data, list(bpy.data.collections)))
        appended_53206 = None if not new_data else new_data[0]
        if bpy.context.view_layer.objects.active:
            prev_context = bpy.context.area.type
            bpy.context.area.type = 'VIEW_3D'
            bpy.ops.view3d.snap_selected_to_active('INVOKE_DEFAULT', )
            bpy.context.area.type = prev_context
        else:
            prev_context = bpy.context.area.type
            bpy.context.area.type = 'VIEW_3D'
            bpy.ops.view3d.snap_selected_to_cursor('INVOKE_DEFAULT', )
            bpy.context.area.type = prev_context
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Add_Light_Ran_Ab4A9(bpy.types.Operator):
    bl_idname = "sna.add_light_ran_ab4a9"
    bl_label = "Add Light Ran"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        if property_exists("bpy.data.objects['TRILIGHTINGCONTROLLER']", globals(), locals()):
            bpy.ops.view3d.snap_cursor_to_active('INVOKE_DEFAULT', )
            import random
            minx = -10
            miny = -10
            minz = 3
            maxx = 10
            maxy = 10
            maxz = 10
            X = random.choice(range(minx,maxx))
            Y = random.choice(range(miny,maxy))
            Z = random.choice(range(minz,maxz))
            intensity = random.choice(range(300,750))
            bpy.ops.object.light_add(type='AREA', align='WORLD', location=(X, Y, Z), scale=(1, 1, 1))
            bpy.context.object.data.energy = intensity
            r = uniform(0,1)
            g = uniform(0,1)
            b = uniform(0,1)
            bpy.context.object.data.color = (r, g, b)
            target_obj = bpy.data.objects['TRILIGHTINGCONTROLLER']
            bpy.ops.object.constraint_add(type='COPY_LOCATION')
            bpy.context.object.constraints["Copy Location"].target = target_obj
            bpy.context.object.constraints["Copy Location"].use_offset = True
            bpy.ops.object.constraint_add(type='TRACK_TO')
            bpy.context.object.constraints["Track To"].target = target_obj
            bpy.ops.object.constraint_add(type='CHILD_OF')
            bpy.context.active_object.constraints["Child Of"].target = bpy.data.objects['TRILIGHTINGCONTROLLER']
            bpy.ops.object.select_all(action='DESELECT')
        else:
            bpy.ops.view3d.snap_cursor_to_active('INVOKE_DEFAULT', )
            bpy.ops.object.empty_add('INVOKE_DEFAULT', type='CUBE', align='CURSOR')
            bpy.context.active_object.name = 'TRILIGHTINGCONTROLLER'
            import random
            minx = -10
            miny = -10
            minz = 3
            maxx = 10
            maxy = 10
            maxz = 10
            X = random.choice(range(minx,maxx))
            Y = random.choice(range(miny,maxy))
            Z = random.choice(range(minz,maxz))
            intensity = random.choice(range(300,750))
            bpy.ops.object.light_add(type='AREA', align='WORLD', location=(X, Y, Z), scale=(1, 1, 1))
            bpy.context.object.data.energy = intensity
            r = uniform(0,1)
            g = uniform(0,1)
            b = uniform(0,1)
            bpy.context.object.data.color = (r, g, b)
            target_obj = bpy.data.objects['TRILIGHTINGCONTROLLER']
            bpy.ops.object.constraint_add(type='COPY_LOCATION')
            bpy.context.object.constraints["Copy Location"].target = target_obj
            bpy.context.object.constraints["Copy Location"].use_offset = True
            bpy.ops.object.constraint_add(type='TRACK_TO')
            bpy.context.object.constraints["Track To"].target = target_obj
            bpy.ops.object.constraint_add(type='CHILD_OF')
            bpy.context.active_object.constraints["Child Of"].target = bpy.data.objects['TRILIGHTINGCONTROLLER']
            bpy.ops.object.select_all(action='DESELECT')
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Renamecontroller_3858C(bpy.types.Operator):
    bl_idname = "sna.renamecontroller_3858c"
    bl_label = "RenameController"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        bpy.data.objects['TRILIGHTINGCONTROLLER'].name = 'AltLightController'
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Freetransform_Light_Ba8F3(bpy.types.Operator):
    bl_idname = "sna.freetransform_light_ba8f3"
    bl_label = "FreeTransform Light"
    bl_description = "Light remains pointed at object but is easier to move with G"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        bpy.context.active_object.constraints.remove(constraint=bpy.context.active_object.constraints['Child Of'], )
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_ALT_TAB_LIGHTING_9EDB6(bpy.types.Panel):
    bl_label = 'Alt Tab Lighting'
    bl_idname = 'SNA_PT_ALT_TAB_LIGHTING_9EDB6'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'Alt Tab Lighting'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        grid_0BDAD = layout.grid_flow(columns=1, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_0BDAD.enabled = True
        grid_0BDAD.active = True
        grid_0BDAD.use_property_split = False
        grid_0BDAD.use_property_decorate = False
        grid_0BDAD.alignment = 'Expand'.upper()
        grid_0BDAD.scale_x = 1.0
        grid_0BDAD.scale_y = 1.0
        grid_0BDAD.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        box_0CB2D = grid_0BDAD.box()
        box_0CB2D.alert = False
        box_0CB2D.enabled = True
        box_0CB2D.active = True
        box_0CB2D.use_property_split = False
        box_0CB2D.use_property_decorate = False
        box_0CB2D.alignment = 'Expand'.upper()
        box_0CB2D.scale_x = 1.0
        box_0CB2D.scale_y = 1.0
        box_0CB2D.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        box_0CB2D.label(text='Presets', icon_value=0)
        box_32DEB = grid_0BDAD.box()
        box_32DEB.alert = False
        box_32DEB.enabled = True
        box_32DEB.active = True
        box_32DEB.use_property_split = False
        box_32DEB.use_property_decorate = False
        box_32DEB.alignment = 'Expand'.upper()
        box_32DEB.scale_x = 1.0
        box_32DEB.scale_y = 1.0
        box_32DEB.operator_context = "INVOKE_DEFAULT" if False else "EXEC_DEFAULT"
        box_32DEB.template_icon_view(bpy.context.scene, 'sna_icongallery', show_labels=True, scale=7.0, scale_popup=5.0)
        op = box_32DEB.operator('sna.appendicon_dbe16', text='Append!', icon_value=0, emboss=True, depress=True)
        box_AD753 = grid_0BDAD.box()
        box_AD753.alert = False
        box_AD753.enabled = True
        box_AD753.active = True
        box_AD753.use_property_split = False
        box_AD753.use_property_decorate = False
        box_AD753.alignment = 'Expand'.upper()
        box_AD753.scale_x = 1.0
        box_AD753.scale_y = 1.0
        box_AD753.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = box_AD753.operator('sna.randomize_lights_run_2502f', text='Randomize All Light Colors', icon_value=0, emboss=True, depress=False)
        op = box_AD753.operator('sna.randomize_selected_d9cd8', text='Randomize Selected Light Colors', icon_value=0, emboss=True, depress=False)
        row_0267F = box_AD753.row(heading='', align=False)
        row_0267F.alert = False
        row_0267F.enabled = True
        row_0267F.active = True
        row_0267F.use_property_split = False
        row_0267F.use_property_decorate = False
        row_0267F.scale_x = 1.0
        row_0267F.scale_y = 1.0
        row_0267F.alignment = 'Expand'.upper()
        row_0267F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_0267F.operator('sna.enable_lights_28e11', text='Enable All Lights', icon_value=0, emboss=True, depress=False)
        op = row_0267F.operator('sna.disable_lights_2584a', text='Disable All Lights', icon_value=0, emboss=True, depress=False)


class SNA_AddonPreferences_3FF95(bpy.types.AddonPreferences):
    bl_idname = __package__

    def draw(self, context):
        if not (False):
            layout = self.layout 
            box_184BC = layout.box()
            box_184BC.alert = False
            box_184BC.enabled = True
            box_184BC.active = True
            box_184BC.use_property_split = False
            box_184BC.use_property_decorate = False
            box_184BC.alignment = 'Expand'.upper()
            box_184BC.scale_x = 1.0
            box_184BC.scale_y = 1.0
            box_184BC.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = box_184BC.operator('wm.url_open', text='Youtube', icon_value=_icons['YouTube_full-color_icon_(2017).svg.png'].icon_id, emboss=True, depress=False)
            op.url = 'https://www.youtube.com/@alttab3d'
            op = box_184BC.operator('wm.url_open', text='Discord', icon_value=_icons['discord-v2-svg.png'].icon_id, emboss=True, depress=False)
            op.url = 'https://discord.gg/uH3mwnwf74'


class SNA_OT_Randomize_Lights_Run_2502F(bpy.types.Operator):
    bl_idname = "sna.randomize_lights_run_2502f"
    bl_label = "Randomize Lights Run"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        select_all_lights()
        for light in selected_objects():
            r = uniform(0,1)
            g = uniform(0,1)
            b = uniform(0,1)
            light.data.color = (r,g,b)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Randomize_Selected_D9Cd8(bpy.types.Operator):
    bl_idname = "sna.randomize_selected_d9cd8"
    bl_label = "Randomize Selected"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        return not False

    def execute(self, context):
        my_objects = selected_objects()
        my_objects = active_object()
        for light in selected_objects():
            r = uniform(0,1)
            g = uniform(0,1)
            b = uniform(0,1)
            light.data.color = (r,g,b)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_NEW_PANEL_69734(bpy.types.Panel):
    bl_label = 'New Panel'
    bl_idname = 'SNA_PT_NEW_PANEL_69734'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_order = 3
    bl_options = {'HIDE_HEADER'}
    bl_parent_id = 'SNA_PT_ALT_TAB_LIGHTING_9EDB6'
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        box_E9EAE = layout.box()
        box_E9EAE.alert = False
        box_E9EAE.enabled = True
        box_E9EAE.active = True
        box_E9EAE.use_property_split = False
        box_E9EAE.use_property_decorate = False
        box_E9EAE.alignment = 'Expand'.upper()
        box_E9EAE.scale_x = 1.0
        box_E9EAE.scale_y = 1.0
        box_E9EAE.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_AF7A0 = box_E9EAE.row(heading='', align=False)
        row_AF7A0.alert = False
        row_AF7A0.enabled = True
        row_AF7A0.active = True
        row_AF7A0.use_property_split = False
        row_AF7A0.use_property_decorate = False
        row_AF7A0.scale_x = 1.0
        row_AF7A0.scale_y = 1.0
        row_AF7A0.alignment = 'Expand'.upper()
        row_AF7A0.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_AF7A0.label(text='Light Manager', icon_value=0)
        box_3E998 = row_AF7A0.box()
        box_3E998.alert = False
        box_3E998.enabled = True
        box_3E998.active = True
        box_3E998.use_property_split = False
        box_3E998.use_property_decorate = False
        box_3E998.alignment = 'Expand'.upper()
        box_3E998.scale_x = 0.699999988079071
        box_3E998.scale_y = 1.0
        box_3E998.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        box_3E998.prop(bpy.context.scene, 'sna_lights_column_count', text='Columns', icon_value=0, emboss=True)
        box_E7C90 = layout.box()
        box_E7C90.alert = False
        box_E7C90.enabled = True
        box_E7C90.active = True
        box_E7C90.use_property_split = False
        box_E7C90.use_property_decorate = False
        box_E7C90.alignment = 'Expand'.upper()
        box_E7C90.scale_x = 1.0
        box_E7C90.scale_y = 1.0
        box_E7C90.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        grid_275D2 = box_E7C90.grid_flow(columns=bpy.context.scene.sna_lights_column_count, row_major=False, even_columns=False, even_rows=False, align=False)
        grid_275D2.enabled = True
        grid_275D2.active = True
        grid_275D2.use_property_split = False
        grid_275D2.use_property_decorate = False
        grid_275D2.alignment = 'Expand'.upper()
        grid_275D2.scale_x = 1.0
        grid_275D2.scale_y = 1.0
        grid_275D2.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        for i_B0884 in range(len(bpy.context.view_layer.objects)):
            if (bpy.context.view_layer.objects[i_B0884].type == 'LIGHT'):
                col_A1125 = grid_275D2.column(heading='', align=False)
                col_A1125.alert = False
                col_A1125.enabled = True
                col_A1125.active = True
                col_A1125.use_property_split = False
                col_A1125.use_property_decorate = False
                col_A1125.scale_x = 1.0
                col_A1125.scale_y = 1.0
                col_A1125.alignment = 'Expand'.upper()
                col_A1125.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_C6E53 = col_A1125.row(heading='', align=False)
                row_C6E53.alert = False
                row_C6E53.enabled = True
                row_C6E53.active = True
                row_C6E53.use_property_split = False
                row_C6E53.use_property_decorate = False
                row_C6E53.scale_x = 1.0
                row_C6E53.scale_y = 1.0
                row_C6E53.alignment = 'Expand'.upper()
                row_C6E53.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_C6E53.prop(bpy.context.view_layer.objects[i_B0884], 'name', text='', icon_value=(299 if (bpy.context.view_layer.objects[i_B0884].data.type == 'SUN') else (300 if (bpy.context.view_layer.objects[i_B0884].data.type == 'SPOT') else (298 if (bpy.context.view_layer.objects[i_B0884].data.type == 'POINT') else (302 if (bpy.context.view_layer.objects[i_B0884].data.type == 'AREA') else 0)))), emboss=True)
                row_C6E53.prop(bpy.context.view_layer.objects[i_B0884], 'hide_select', text='', icon_value=(41 if bpy.context.view_layer.objects[i_B0884].hide_select else 40), emboss=True)
                row_C6E53.prop(bpy.context.view_layer.objects[i_B0884], 'hide_viewport', text='', icon_value=0, emboss=True)
                row_C6E53.prop(bpy.context.view_layer.objects[i_B0884], 'hide_render', text='', icon_value=0, emboss=True)
                row_DB4E2 = col_A1125.row(heading='', align=False)
                row_DB4E2.alert = False
                row_DB4E2.enabled = True
                row_DB4E2.active = True
                row_DB4E2.use_property_split = False
                row_DB4E2.use_property_decorate = False
                row_DB4E2.scale_x = 1.0
                row_DB4E2.scale_y = 1.0
                row_DB4E2.alignment = 'Expand'.upper()
                row_DB4E2.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_DB4E2.prop(bpy.context.view_layer.objects[i_B0884].data, 'color', text='', icon_value=0, emboss=True)
                row_DB4E2.prop(bpy.context.view_layer.objects[i_B0884].data, 'energy', text='', icon_value=0, emboss=True)


class SNA_PT_PROCEDURAL_LIGHTING_E695A(bpy.types.Panel):
    bl_label = 'Procedural Lighting'
    bl_idname = 'SNA_PT_PROCEDURAL_LIGHTING_E695A'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_order = 0
    bl_options = {'HIDE_HEADER', 'DEFAULT_CLOSED'}
    bl_parent_id = 'SNA_PT_ALT_TAB_LIGHTING_9EDB6'
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        box_ACB61 = layout.box()
        box_ACB61.alert = False
        box_ACB61.enabled = True
        box_ACB61.active = True
        box_ACB61.use_property_split = False
        box_ACB61.use_property_decorate = False
        box_ACB61.alignment = 'Expand'.upper()
        box_ACB61.scale_x = 1.0
        box_ACB61.scale_y = 1.0
        box_ACB61.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        box_ACB61.label(text='Procedural Lighting', icon_value=0)
        box_E5232 = layout.box()
        box_E5232.alert = False
        box_E5232.enabled = True
        box_E5232.active = True
        box_E5232.use_property_split = False
        box_E5232.use_property_decorate = False
        box_E5232.alignment = 'Expand'.upper()
        box_E5232.scale_x = 1.0
        box_E5232.scale_y = 1.0
        box_E5232.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        if (bpy.context.view_layer.objects.selected or property_exists("bpy.data.objects['TRILIGHTINGCONTROLLER'].name", globals(), locals())):
            pass
        else:
            box_E5232.label(text='Select an object!', icon_value=0)
        op = box_E5232.operator('sna.add_light_ran_ab4a9', text=('+1' if property_exists("bpy.data.objects['TRILIGHTINGCONTROLLER']", globals(), locals()) else 'Add Random Light'), icon_value=0, emboss=True, depress=False)
        if bpy.context.view_layer.objects.active.type == 'LIGHT':
            if (property_exists("bpy.context.active_object.constraints['Child Of']", globals(), locals()) and bpy.context.view_layer.objects.selected):
                op = box_E5232.operator('sna.freetransform_light_ba8f3', text='Remove Light Location Constraints', icon_value=0, emboss=True, depress=False)
            else:
                box_E5232.label(text='Nothing to see here, select another light or object.', icon_value=0)
        if property_exists("bpy.data.objects['TRILIGHTINGCONTROLLER'].name", globals(), locals()):
            row_EBC5A = box_E5232.row(heading='', align=False)
            row_EBC5A.alert = False
            row_EBC5A.enabled = True
            row_EBC5A.active = True
            row_EBC5A.use_property_split = False
            row_EBC5A.use_property_decorate = False
            row_EBC5A.scale_x = 1.0
            row_EBC5A.scale_y = 1.0
            row_EBC5A.alignment = 'Expand'.upper()
            row_EBC5A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = row_EBC5A.operator('sna.renamecontroller_3858c', text='Confirm', icon_value=0, emboss=True, depress=True)


class SNA_GROUP_sna_group_property(bpy.types.PropertyGroup):
    pointer: bpy.props.PointerProperty(name='Pointer', description='', type=bpy.types.Object)


def sna_tttt_enum_items(self, context):
    return [("No Items", "No Items", "No generate enum items node found to create items!", "ERROR", 0)]


def sna_camera_list_enum_items(self, context):
    return [("No Items", "No Items", "No generate enum items node found to create items!", "ERROR", 0)]


def sna_camerapathenum_enum_items(self, context):
    return [("No Items", "No Items", "No generate enum items node found to create items!", "ERROR", 0)]


def sna_custom_props_enum_enum_items(self, context):
    return [("No Items", "No Items", "No generate enum items node found to create items!", "ERROR", 0)]


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.utils.register_class(SNA_GROUP_sna_group_property)
    bpy.utils.register_class(SNA_OT_Appendicon_Dbe16)
    bpy.types.Scene.sna_custtoglprop = bpy.props.EnumProperty(name='CustToglProp', description='', items=[('Lighting', 'Lighting', '', 0, 0)])
    bpy.types.Scene.sna_select_light = bpy.props.BoolProperty(name='select_light', description='', default=False)
    bpy.types.Scene.sna_geoboolean1 = bpy.props.BoolProperty(name='GeoBoolean1', description='', default=False)
    bpy.types.Scene.sna_geoboolean2 = bpy.props.BoolProperty(name='GeoBoolean2', description='', default=False)
    bpy.types.Scene.sna_geoboolean3 = bpy.props.BoolProperty(name='GeoBoolean3', description='', default=False)
    bpy.types.Scene.sna_geoboolean4 = bpy.props.BoolProperty(name='GeoBoolean4', description='', default=False)
    bpy.types.Scene.sna_geoboolean5 = bpy.props.BoolProperty(name='GeoBoolean5', description='', default=False)
    bpy.types.Scene.sna_geoboolean_6 = bpy.props.BoolProperty(name='GeoBoolean 6', description='', default=False)
    bpy.types.Scene.sna_test = bpy.props.IntProperty(name='Test', description='', default=0, subtype='NONE')
    bpy.types.Scene.sna_tttt = bpy.props.EnumProperty(name='Tttt', description='', items=sna_tttt_enum_items)
    bpy.types.Scene.sna_mouse_clicks = bpy.props.IntProperty(name='Mouse Clicks', description='', default=0, subtype='NONE')
    bpy.types.Scene.sna_keystrokes = bpy.props.IntProperty(name='Keystrokes', description='', default=0, subtype='NONE')
    bpy.types.Scene.sna_stop_tracking = bpy.props.BoolProperty(name='Stop Tracking', description='', default=False)
    bpy.types.Scene.sna_camera_list = bpy.props.EnumProperty(name='Camera List', description='Cameras', items=sna_camera_list_enum_items)
    bpy.types.Scene.sna_hide_user_prefs = bpy.props.BoolProperty(name='hide_user_prefs', description='', default=False)
    bpy.types.Scene.sna_material_name = bpy.props.StringProperty(name='Material Name', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_coliumns = bpy.props.IntProperty(name='Coliumns', description='', default=1, subtype='NONE')
    bpy.types.Scene.sna_icongallery = bpy.props.EnumProperty(name='IconGallery', description='', items=sna_icongallery_enum_items)
    bpy.types.Scene.sna_attachcameraname = bpy.props.StringProperty(name='AttachCameraName', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_camerapathenum = bpy.props.EnumProperty(name='CameraPathEnum', description='', items=sna_camerapathenum_enum_items)
    bpy.types.Scene.sna_activenodeproperty = bpy.props.PointerProperty(name='ActiveNodeProperty', description='', type=bpy.types.Scene)
    bpy.types.Scene.sna_activenodelocation = bpy.props.FloatVectorProperty(name='ActiveNodeLocation', description='', size=2, default=(0.0, 0.0), subtype='NONE', unit='NONE', step=3, precision=6)
    bpy.types.Scene.sna_imagesizevalue = bpy.props.IntProperty(name='ImageSizeValue', description='', default=1024, subtype='NONE')
    bpy.types.Scene.sna_storeimagename = bpy.props.StringProperty(name='StoreImageName', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_storerendersamples = bpy.props.IntProperty(name='StoreRenderSamples', description='', default=0, subtype='NONE')
    bpy.types.Scene.sna_setrendersamples = bpy.props.IntProperty(name='SetRenderSamples', description='', default=1, subtype='NONE')
    bpy.types.Scene.sna_timerbool = bpy.props.BoolProperty(name='TimerBool', description='', default=False)
    bpy.types.Scene.sna_index = bpy.props.IntProperty(name='Index', description='', default=0, subtype='NONE')
    bpy.types.Scene.sna_type_enum = bpy.props.EnumProperty(name='TYPE ENUM', description='', items=[('MESH', 'MESH', 'MESH', 0, 0), ('LIGHT', 'LIGHT', 'LIGHT', 0, 1), ('EMPTY', 'EMPTY', 'EMPTY', 0, 2), ('CURVE', 'CURVE', 'CURVE', 0, 3), ('CAMERA', 'CAMERA', 'CAMERA', 0, 4)])
    bpy.types.Scene.sna_selectbysubstring = bpy.props.StringProperty(name='SelectBySubstring', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_collection = bpy.props.CollectionProperty(name='Collection', description='', type=SNA_GROUP_sna_group_property)
    bpy.types.Scene.sna_enum = bpy.props.IntProperty(name='ENUM', description='', default=0, subtype='NONE')
    bpy.types.Scene.sna_first_time = bpy.props.IntProperty(name='First time', description='', default=0, subtype='NONE', min=0)
    bpy.types.Scene.sna_second_time_save = bpy.props.IntProperty(name='Second Time (save)', description='', default=0, subtype='NONE', min=0)
    bpy.types.Scene.sna_display_time = bpy.props.IntProperty(name='DISPLAY TIME', description='', default=0, subtype='NONE', min=0)
    bpy.types.Scene.sna_hours = bpy.props.FloatProperty(name='Hours', description='', default=0.0, subtype='NONE', unit='NONE', step=3, precision=1)
    bpy.types.Scene.sna_name = bpy.props.StringProperty(name='NAME', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_save_render_engine = bpy.props.StringProperty(name='Save Render Engine', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_timer_boolean = bpy.props.BoolProperty(name='TIMER BOOLEAN', description='', default=False)
    bpy.types.Scene.sna_lightbigpicturecolumns = bpy.props.IntProperty(name='LightBigPictureColumns', description='', default=1, subtype='NONE', min=1, soft_min=1, max=8, soft_max=8)
    bpy.types.Scene.sna_materialbigpicturecolumns = bpy.props.IntProperty(name='MaterialBigPictureColumns', description='', default=1, subtype='NONE', min=1, soft_min=1, max=8, soft_max=8)
    bpy.types.Scene.sna_material_column_count = bpy.props.IntProperty(name='MATERIAL COLUMN COUNT', description='', default=1, subtype='NONE', min=1, soft_min=1, max=8, soft_max=8)
    bpy.types.Scene.sna_lights_column_count = bpy.props.IntProperty(name='LIGHTS COLUMN COUNT', description='', default=1, subtype='NONE', min=1, soft_min=1, max=8, soft_max=8)
    bpy.types.Scene.sna_custom_props_enum = bpy.props.EnumProperty(name='Custom_Props_Enum', description='', items=sna_custom_props_enum_enum_items)
    bpy.utils.register_class(SNA_OT_Disable_Lights_2584A)
    bpy.utils.register_class(SNA_OT_Enable_Lights_28E11)
    if not 'splitcold.png' in _icons: _icons.load('splitcold.png', os.path.join(os.path.dirname(__file__), 'icons', 'splitcold.png'), "IMAGE")
    if not 'ice.png' in _icons: _icons.load('ice.png', os.path.join(os.path.dirname(__file__), 'icons', 'ice.png'), "IMAGE")
    if not 'gentlecold.png' in _icons: _icons.load('gentlecold.png', os.path.join(os.path.dirname(__file__), 'icons', 'gentlecold.png'), "IMAGE")
    if not 'cleanwhite.png' in _icons: _icons.load('cleanwhite.png', os.path.join(os.path.dirname(__file__), 'icons', 'cleanwhite.png'), "IMAGE")
    if not 'radialstage.png' in _icons: _icons.load('radialstage.png', os.path.join(os.path.dirname(__file__), 'icons', 'radialstage.png'), "IMAGE")
    if not 'deeppurple.png' in _icons: _icons.load('deeppurple.png', os.path.join(os.path.dirname(__file__), 'icons', 'deeppurple.png'), "IMAGE")
    if not 'splitwarm.png' in _icons: _icons.load('splitwarm.png', os.path.join(os.path.dirname(__file__), 'icons', 'splitwarm.png'), "IMAGE")
    if not 'warmmorning.png' in _icons: _icons.load('warmmorning.png', os.path.join(os.path.dirname(__file__), 'icons', 'warmmorning.png'), "IMAGE")
    if not 'pastel.png' in _icons: _icons.load('pastel.png', os.path.join(os.path.dirname(__file__), 'icons', 'pastel.png'), "IMAGE")
    if not 'gentlewarm.png' in _icons: _icons.load('gentlewarm.png', os.path.join(os.path.dirname(__file__), 'icons', 'gentlewarm.png'), "IMAGE")
    if not 'warmpink.png' in _icons: _icons.load('warmpink.png', os.path.join(os.path.dirname(__file__), 'icons', 'warmpink.png'), "IMAGE")
    if not 'softspot.png' in _icons: _icons.load('softspot.png', os.path.join(os.path.dirname(__file__), 'icons', 'softspot.png'), "IMAGE")
    if not 'softwarm.png' in _icons: _icons.load('softwarm.png', os.path.join(os.path.dirname(__file__), 'icons', 'softwarm.png'), "IMAGE")
    if not 'hotncold.png' in _icons: _icons.load('hotncold.png', os.path.join(os.path.dirname(__file__), 'icons', 'hotncold.png'), "IMAGE")
    if not 'toxic.png' in _icons: _icons.load('toxic.png', os.path.join(os.path.dirname(__file__), 'icons', 'toxic.png'), "IMAGE")
    if not 's1.png' in _icons: _icons.load('s1.png', os.path.join(os.path.dirname(__file__), 'icons', 's1.png'), "IMAGE")
    if not 's2.png' in _icons: _icons.load('s2.png', os.path.join(os.path.dirname(__file__), 'icons', 's2.png'), "IMAGE")
    if not 's3.png' in _icons: _icons.load('s3.png', os.path.join(os.path.dirname(__file__), 'icons', 's3.png'), "IMAGE")
    if not 's4.png' in _icons: _icons.load('s4.png', os.path.join(os.path.dirname(__file__), 'icons', 's4.png'), "IMAGE")
    if not 's5.png' in _icons: _icons.load('s5.png', os.path.join(os.path.dirname(__file__), 'icons', 's5.png'), "IMAGE")
    if not 's6.png' in _icons: _icons.load('s6.png', os.path.join(os.path.dirname(__file__), 'icons', 's6.png'), "IMAGE")
    if not 's7.png' in _icons: _icons.load('s7.png', os.path.join(os.path.dirname(__file__), 'icons', 's7.png'), "IMAGE")
    if not 's8.png' in _icons: _icons.load('s8.png', os.path.join(os.path.dirname(__file__), 'icons', 's8.png'), "IMAGE")
    if not 's9.png' in _icons: _icons.load('s9.png', os.path.join(os.path.dirname(__file__), 'icons', 's9.png'), "IMAGE")
    if not 's10.png' in _icons: _icons.load('s10.png', os.path.join(os.path.dirname(__file__), 'icons', 's10.png'), "IMAGE")
    if not 's11.png' in _icons: _icons.load('s11.png', os.path.join(os.path.dirname(__file__), 'icons', 's11.png'), "IMAGE")
    if not 's16.png' in _icons: _icons.load('s16.png', os.path.join(os.path.dirname(__file__), 'icons', 's16.png'), "IMAGE")
    if not 's19.png' in _icons: _icons.load('s19.png', os.path.join(os.path.dirname(__file__), 'icons', 's19.png'), "IMAGE")
    if not 's20.png' in _icons: _icons.load('s20.png', os.path.join(os.path.dirname(__file__), 'icons', 's20.png'), "IMAGE")
    if not 's21.png' in _icons: _icons.load('s21.png', os.path.join(os.path.dirname(__file__), 'icons', 's21.png'), "IMAGE")
    if not 's22.png' in _icons: _icons.load('s22.png', os.path.join(os.path.dirname(__file__), 'icons', 's22.png'), "IMAGE")
    if not 's23.png' in _icons: _icons.load('s23.png', os.path.join(os.path.dirname(__file__), 'icons', 's23.png'), "IMAGE")
    if not 's24.png' in _icons: _icons.load('s24.png', os.path.join(os.path.dirname(__file__), 'icons', 's24.png'), "IMAGE")
    if not 's25.png' in _icons: _icons.load('s25.png', os.path.join(os.path.dirname(__file__), 'icons', 's25.png'), "IMAGE")
    if not 's26.png' in _icons: _icons.load('s26.png', os.path.join(os.path.dirname(__file__), 'icons', 's26.png'), "IMAGE")
    if not 's27.png' in _icons: _icons.load('s27.png', os.path.join(os.path.dirname(__file__), 'icons', 's27.png'), "IMAGE")
    if not 's28.png' in _icons: _icons.load('s28.png', os.path.join(os.path.dirname(__file__), 'icons', 's28.png'), "IMAGE")
    if not 's29.png' in _icons: _icons.load('s29.png', os.path.join(os.path.dirname(__file__), 'icons', 's29.png'), "IMAGE")
    if not 's30.png' in _icons: _icons.load('s30.png', os.path.join(os.path.dirname(__file__), 'icons', 's30.png'), "IMAGE")
    if not 's31.png' in _icons: _icons.load('s31.png', os.path.join(os.path.dirname(__file__), 'icons', 's31.png'), "IMAGE")
    if not 's32.png' in _icons: _icons.load('s32.png', os.path.join(os.path.dirname(__file__), 'icons', 's32.png'), "IMAGE")
    if not 's33.png' in _icons: _icons.load('s33.png', os.path.join(os.path.dirname(__file__), 'icons', 's33.png'), "IMAGE")
    if not 's34.png' in _icons: _icons.load('s34.png', os.path.join(os.path.dirname(__file__), 'icons', 's34.png'), "IMAGE")
    if not 's35.png' in _icons: _icons.load('s35.png', os.path.join(os.path.dirname(__file__), 'icons', 's35.png'), "IMAGE")

    bpy.utils.register_class(SNA_OT_Add_Light_Ran_Ab4A9)
    bpy.utils.register_class(SNA_OT_Renamecontroller_3858C)
    bpy.utils.register_class(SNA_OT_Freetransform_Light_Ba8F3)
    bpy.utils.register_class(SNA_PT_ALT_TAB_LIGHTING_9EDB6)
    bpy.utils.register_class(SNA_AddonPreferences_3FF95)
    if not 'YouTube_full-color_icon_(2017).svg.png' in _icons: _icons.load('YouTube_full-color_icon_(2017).svg.png', os.path.join(os.path.dirname(__file__), 'icons', 'YouTube_full-color_icon_(2017).svg.png'), "IMAGE")
    if not 'discord-v2-svg.png' in _icons: _icons.load('discord-v2-svg.png', os.path.join(os.path.dirname(__file__), 'icons', 'discord-v2-svg.png'), "IMAGE")
    bpy.utils.register_class(SNA_OT_Randomize_Lights_Run_2502F)
    bpy.utils.register_class(SNA_OT_Randomize_Selected_D9Cd8)
    bpy.utils.register_class(SNA_PT_NEW_PANEL_69734)
    bpy.utils.register_class(SNA_PT_PROCEDURAL_LIGHTING_E695A)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_custom_props_enum
    del bpy.types.Scene.sna_lights_column_count
    del bpy.types.Scene.sna_material_column_count
    del bpy.types.Scene.sna_materialbigpicturecolumns
    del bpy.types.Scene.sna_lightbigpicturecolumns
    del bpy.types.Scene.sna_timer_boolean
    del bpy.types.Scene.sna_save_render_engine
    del bpy.types.Scene.sna_name
    del bpy.types.Scene.sna_hours
    del bpy.types.Scene.sna_display_time
    del bpy.types.Scene.sna_second_time_save
    del bpy.types.Scene.sna_first_time
    del bpy.types.Scene.sna_enum
    del bpy.types.Scene.sna_collection
    del bpy.types.Scene.sna_selectbysubstring
    del bpy.types.Scene.sna_type_enum
    del bpy.types.Scene.sna_index
    del bpy.types.Scene.sna_timerbool
    del bpy.types.Scene.sna_setrendersamples
    del bpy.types.Scene.sna_storerendersamples
    del bpy.types.Scene.sna_storeimagename
    del bpy.types.Scene.sna_imagesizevalue
    del bpy.types.Scene.sna_activenodelocation
    del bpy.types.Scene.sna_activenodeproperty
    del bpy.types.Scene.sna_camerapathenum
    del bpy.types.Scene.sna_attachcameraname
    del bpy.types.Scene.sna_icongallery
    del bpy.types.Scene.sna_coliumns
    del bpy.types.Scene.sna_material_name
    del bpy.types.Scene.sna_hide_user_prefs
    del bpy.types.Scene.sna_camera_list
    del bpy.types.Scene.sna_stop_tracking
    del bpy.types.Scene.sna_keystrokes
    del bpy.types.Scene.sna_mouse_clicks
    del bpy.types.Scene.sna_tttt
    del bpy.types.Scene.sna_test
    del bpy.types.Scene.sna_geoboolean_6
    del bpy.types.Scene.sna_geoboolean5
    del bpy.types.Scene.sna_geoboolean4
    del bpy.types.Scene.sna_geoboolean3
    del bpy.types.Scene.sna_geoboolean2
    del bpy.types.Scene.sna_geoboolean1
    del bpy.types.Scene.sna_select_light
    del bpy.types.Scene.sna_custtoglprop
    bpy.utils.unregister_class(SNA_GROUP_sna_group_property)
    bpy.utils.unregister_class(SNA_OT_Disable_Lights_2584A)
    bpy.utils.unregister_class(SNA_OT_Enable_Lights_28E11)
    bpy.utils.unregister_class(SNA_OT_Appendicon_Dbe16)
    bpy.utils.unregister_class(SNA_OT_Add_Light_Ran_Ab4A9)
    bpy.utils.unregister_class(SNA_OT_Renamecontroller_3858C)
    bpy.utils.unregister_class(SNA_OT_Freetransform_Light_Ba8F3)
    bpy.utils.unregister_class(SNA_PT_ALT_TAB_LIGHTING_9EDB6)
    bpy.utils.unregister_class(SNA_AddonPreferences_3FF95)
    bpy.utils.unregister_class(SNA_OT_Randomize_Lights_Run_2502F)
    bpy.utils.unregister_class(SNA_OT_Randomize_Selected_D9Cd8)
    bpy.utils.unregister_class(SNA_PT_NEW_PANEL_69734)
    bpy.utils.unregister_class(SNA_PT_PROCEDURAL_LIGHTING_E695A)
